--[[
Don't edit or remove this comment block! It is used by the editor to store information since i'm too lazy to write a good LUA parser... -Haz
SETTINGS
RestrictedEnhancements=
RestrictedCategories=
END

BY yoletx

USED :
- photoshop ^^
- official editor
- hazardx marker editor
- BBF_BSD map for create dialog idea
- some of my last map (wave_of_death) functions

--]]

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')

local armyStats = {} --Tableau contenant un tableau par joueur : army_x, tempsrestant en sec, pourcentage capture point central(0 = 0%, -1 = le king), le pseudo

local ended = {}


local premierePlace = 1
local dernierePlace = 8
local nombreJoueurs = 0

local actualiserScores = false

local currentResSpot = 1
local massSpot =
{
	["ARMY_1"] = 	{
						{323,50},
						{336,48},
						{323,60},
						{340,60},
						{330,30},
						{355,55},
						{339,82},
						{306,54}
					},
	["ARMY_2"] = 	{
						{441,168},
						{461,165},
						{460,179},
						{440,180},
						{451,147},
						{471,170},
						{449,200},
						{426,170}
					},
	["ARMY_3"] = 	{
						{449,329},
						{462,326},
						{461,337},
						{448,341},
						{434,312},
						{471,313},
						{470,348},
						{438,356}
					},
	["ARMY_4"] = 	{
						{330,443},
						{342,438},
						{345,454},
						{331,456},
						{337,424},
						{360,449},
						{336,474},
						{308,447}
					},
	["ARMY_5"] = 	{
						{176,444},
						{194,444},
						{191,459},
						{178,459},
						{177,425},
						{208,457},
						{177,480},
						{158,454}
					},
	["ARMY_6"] = 	{
						{57,326},
						{73,330},
						{71,341},
						{56,336},
						{56,314},
						{84,313},
						{82,353},
						{42,346}
					},
	["ARMY_7"] = 	{
						{47,173},
						{64,170},
						{68,187},
						{52,190},
						{58,156},
						{85,175},
						{65,204},
						{33,178}
					},
	["ARMY_8"] = 	{
						{168,56},
						{187,53},
						{186,68},
						{173,70},
						{178,40},
						{200,63},
						{175,89},
						{152,63}
					}
}

local energySpot =
{
	["ARMY_1"] = 	{314,35},
	["ARMY_2"] = 	{437,151},
	["ARMY_3"] = 	{460,309},
	["ARMY_4"] = 	{321,468},
	["ARMY_5"] = 	{198,475},
	["ARMY_6"] = 	{56,362},
	["ARMY_7"] = 	{46,163},
	["ARMY_8"] = 	{160,47}
}

local scoreTable = {}
local scoreDialog = nil

local language = "english" --french or english

local languageText =
{
	["english"] =
	{
		["startcap"] = " begins capturing !",
		["newking"] = " is a new KING !",
		["capture"] = "Capturing : ",
		["king"] = "KING : ",
		["first"] = "1st",
		["second"] = "2nd",
		["third"] = "3rd",
		["otherplace"] = "th",
		["last"] = "last",
		["help1"] = "Keep your ACU alive !",
		["help2"] = "Your score is the number of seconds remaining to victory",
		["help3"] = "Hold the center point away from enemies during ",
		["help4"] = " seconds to start reducing your total time",
	},
	["francais"] =
	{
		["startcap"] = " commence la capture !",
		["newking"] = " est un nouveau KING !",
		["capture"] = "Capture : ",
		["king"] = "KING : ",
		["first"] = "1er",
		["second"] = "2eme",
		["third"] = "3eme",
		["otherplace"] = "eme",
		["last"] = "dernier",
		["help1"] = "Gardez votre commander en vie !",
		["help2"] = "Votre score est le nombre de secondes restantes a ecouler avant de gagner",
		["help3"] = "Gardez le controle du point central a l'ecart des enemies pendant ",
		["help4"] = " secondes pour commencer a reduire votre temps total.",
	},
}

local helps = { 
				["help1"] = 10, --Temps avant d'affiche le message (chaque messages s'affiche 6 secondes)
				["help2"] = 20,
				["help3et4"] = 30
				}


local duree_king = 30
local pourcentageStep = 0
				
function OnPopulate()
  ScenarioUtils.InitializeArmies()
  for j, army in ListArmies() do
	for m, mass in massSpot[army] do
		GenerateResourcesMarker(mass[1], mass[2])
	end
	GenerateGasResourcesMarker(energySpot[army][1], energySpot[army][2])
  end
end

function OnStart(self)
	local temps = 900
	if(ScenarioInfo.Options.opt_duree!=nil) then
		temps = ScenarioInfo.Options.opt_duree
	end
	if(ScenarioInfo.Options.UnitCap == nil)then --Sinon bug dans l'abandonnedbyplayer
		ScenarioInfo.Options.UnitCap = 0
	end

	if(ScenarioInfo.Options.opt_language!=nil) then
		if( ScenarioInfo.Options.opt_language == 2 ) then
			language = "francais"
		end
	end
	
	if(ScenarioInfo.Options.opt_duree_king!=nil) then
		duree_king = ScenarioInfo.Options.opt_duree_king
	end
	pourcentageStep = (100/duree_king)
	

	for j, army in ListArmies() do
		t = { army, temps, 0, GetArmyBrain(army).Nickname}
		table.insert(armyStats,t)
		nombreJoueurs = nombreJoueurs + 1
		ScenarioFramework.AddRestriction(army, categories.ueb2108)
		ScenarioFramework.AddRestriction(army, categories.uab2108)
		ScenarioFramework.AddRestriction(army, categories.urb2108)
		ScenarioFramework.AddRestriction(army, categories.xsb2108)
	end
	dernierePlace = nombreJoueurs
	
	for j = 1, nombreJoueurs, 1  do
		table.insert(scoreTable, getPlace( j ).." : ")
	end

	for index, brain in ArmyBrains do --Scores
		brain.CalculateScore = function(thisBrain)
			army = indexToArmy(thisBrain:GetArmyIndex())
			duree = 0;
			for i, currentArmyTemps in armyStats do --on parcours tous les temps restant
				if currentArmyTemps[1]==army then --On r�cup�re le bon temps
					return currentArmyTemps[2]
				end
			end
			return 0
		end
	end

	
	if(ScenarioInfo.Options.opt_color_king == 1 or ScenarioInfo.Options.opt_color_king == nil)then
		changeColor()
	end
	verificateurZone()
	refreshDialog()
	refreshLine()
	--majScores()
	modeAssassina()
end

verificateurZone = function()
	ForkThread( function()
		while true do
			--ETAPE 1 : TOUS LES KINGS QUI NE S'AIMENT PAS NE SONT PLUS KING ;)
			--On commence par r�cup�rer tous les kings 
			local kingListe = {}
			for i, currentArmy in armyStats do
				if(currentArmy[3] == -1)then
					table.insert(kingListe, currentArmy[1])
				end
			end
			
			local kingToFire = {}
			for i, currentKing in kingListe do
				kingToFire[currentKing] = false
			end
			
			for i, currentKing in kingListe do
				for j, currentArmy in armyStats do
					if(currentKing == currentArmy[1])then --King li� a army stats
						for i2, currentKing2 in kingListe do
							for j, currentArmyPossibleEnemy in armyStats do 
								if(currentKing2 == currentArmyPossibleEnemy[1])then--King 2 li� a possibleEnemy
									if(currentKing != currentKing2)then --Si ce n'est pas lui m�me
										if(IsEnemy(currentKing, currentArmyPossibleEnemy[1]))then
											kingToFire[currentKing] = true
										end
									end
								end
							end
						end
					end
				end
			end
			
			--Maintenant on vire tous les mauvais king
			for kingName, kingValue in kingToFire do
				if(kingValue)then
					for i, currentArmy in armyStats do
						if(currentArmy[1] == kingName)then
							currentArmy[3] = 0
							remettreCouleurOrigine(currentArmy[1])
						end
					end
				end
			end
			
			
			--ETAPE 2 : QUI EST AU CENTRE ET N'A PAS D'ADVERSAIRES AU CENTRE �GALEMENT ?
			local listArmy = {}
			

			for i, currentArmyTemps in armyStats do --on parcours tous les joueurs
				table.insert( listArmy, { currentArmyTemps[1], 0})
			end

			local unitAuCentre = GetUnitsInRect({x0 = 233, x1 = 276, y0 = 238, y1 = 274})
			if(unitAuCentre~=nil)then
				for i,unit in unitAuCentre do --On r�cup toutes les unit�s dans la zone de capture
					if(EntityCategoryContains(categories.LAND,unit))then
						for j,currentArmy in listArmy do
							if(currentArmy[1] == indexToArmy(unit:GetArmy()))then
								currentArmy[2] = currentArmy[2] + 1
							end
						end
					end
				end
			end

			local armyAuCentre = {}
			for i, currentArmy in listArmy do --Pour chacun des joueurs
				if(currentArmy[2] != 0)then --Si le joueur poss�de au moins une unit�, on l'ajoute aux autre
					table.insert(armyAuCentre, currentArmy[1])
				end
			end
			
			
			--On va enlever tous les joueurs qui poss�dent un enemie juste a cot� d'eux au centre
			armyAuCentreTmp = {}
			for i, currentArmy in armyAuCentre do
				armyAuCentreTmp[currentArmy] = true
			end
			
			for i, currentArmy1 in armyAuCentre do
				for j, currentArmy2 in armyAuCentre do
					if(currentArmy1 != currentArmy2)then
						if(IsEnemy(currentArmy1, currentArmy2))then
							armyAuCentreTmp[currentArmy1] = false
							armyAuCentreTmp[currentArmy2] = false
						end
					end
				end
			end
			
			armyAuCentre = {}
			for currentArmy, currentVal in armyAuCentreTmp do
				if(currentVal)then
					table.insert(armyAuCentre,currentArmy)
				end
			end
		

			--Si armyAuCentre est vide alors c'est qu'il n'y a personne ou bien plus d'un joueur
			--   Dans ce cas on d�cr�mente le pourcentage de prise

			if(table.getn(armyAuCentre)==0)then
				for i, currentArmy in armyStats do
					if(currentArmy[3] > 0) then
						currentArmy[3] = currentArmy[3] - 0.1
					end
				end
			end

			--ETAPE 3, TRAITEMENT DES JOUEURS AU CENTRE
			--Pour chacun des joueurs au centre
			--	Si le joueur est king on ne change rien
			--	Si le joueur n'est pas king :
			--		Si il poss�de un adversaire ayant un pourcentage on le d�cr�mente, et on stock cet adversaire, pour dire qu'il ne d�cr�mentera plus pendant ce tour
			-- 		Sinon on augmente son pourcentage
			--			Si le pourcentage arrive � 100, passage king et suppression du king pour ses adversaires
			local armyDecremented = {} --Liste des joueurs a qui on a d�cr�ment� la capture
			
			
			for indexArmy, currentArmy in armyStats do --Tous les joueurs de la partie
				for indexArmyAuCentre, currentArmyAuCentre in armyAuCentre do --Les joueurs au centre
					if currentArmy[1] == currentArmyAuCentre then --currentArmy est li� � currentArmyAuCentre
						local nomArmyAuCentre = currentArmy[1]
						if currentArmy[3] == -1 then
							break
						end
						
						local haveDecremented = false --Si on a trouv� un enemy a d�cr�menter alors, on ne pourra pas augmenter son propre pourcentage pendant ce round
						for indexArmyPossibleEnemy, currentArmyPossibleEnemy in armyStats do
							if(currentArmyPossibleEnemy[1] != nomArmyAuCentre and IsEnemy(currentArmyPossibleEnemy[1], nomArmyAuCentre) and currentArmyPossibleEnemy[3] > 0)then --Si on a trouv� un enemi avec un pourcentage sup � 0
								local foundDecremented = false
								for indexArmyDecremented, currentArmyDecremented in armyDecremented do
									if(currentArmyDecremented == currentArmyPossibleEnemy[1])then
										foundDecremented = true
										break
									end
								end
								if(not foundDecremented)then --Ce joueur n'a pas �t� d�cr�ment�, on peu le d�cr�menter et l'ajouter � la liste
									currentArmyPossibleEnemy[3] = currentArmyPossibleEnemy[3] - pourcentageStep
									table.insert(armyDecremented, currentArmyPossibleEnemy[1])
								end
								haveDecremented = true
							end
						end
						
						if(not haveDecremented)then --Sinon on peu augmenter son propre pourcentage
							if(currentArmy[3] == 0)then
								PrintText(currentArmy[4]..languageText[language]["startcap"], 15, 'ffff0000', 5, 'center')
							end
							currentArmy[3] = currentArmy[3] + pourcentageStep
							if(currentArmy[3] >= 100)then --On va le passer en king, et tous ses enemi ne seront plus king
								currentArmy[3] = -1
								PrintText(currentArmy[4]..languageText[language]["newking"], 15, 'ffff0000', 5, 'center')
								for indexArmyPossibleEnemy, currentArmyPossibleEnemy in armyStats do
									if(currentArmyPossibleEnemy[1] != nomArmyAuCentre and IsEnemy(currentArmyPossibleEnemy[1], nomArmyAuCentre) and currentArmyPossibleEnemy[3] == -1)then
										currentArmyPossibleEnemy[3] = 0 --Ce joueur n'est plus un king
										remettreCouleurOrigine(currentArmyPossibleEnemy[1])
									end
								end
							end
						end
					end
				end
			end
			
			for i, currentArmy in armyStats do --On diminue le temps du(des) KING
				if(currentArmy[3] == -1)then
					currentArmy[2] = currentArmy[2] - 1
					verificationVainceur()
				end
			end



			WaitSeconds( 1 )
		end
	end)
end

verificationVainceur = function()
	for i, currentArmyTemps in armyStats do
		if(currentArmyTemps[2] <= 0) then
			currentArmyTemps[2] = 0
			currentArmyTemps[3] = 0
			afficherFinJoueur( currentArmyTemps[1])			
		end
	end
end

indexToArmy = function(armyIndex)
   local army = ListArmies()[armyIndex]
   return army
end

modeAssassina = function()
	for i, army in ListArmies() do
		if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6" or army == "ARMY_7" or army == "ARMY_8") then
			local aiBrain = GetArmyBrain(army);
			local units = aiBrain:GetListOfUnits(categories.ALLUNITS - categories.WALL, false)
			for j,unit in units do
				local bp = unit:GetBlueprint()
				if(isACU(bp.BlueprintId))then
					unit.OldOnKilled = unit.OnKilled
					unit.OnKilled = commander_destruction
				end
			end
		end
	end

end

commander_destruction = function(self, instigator, type_, overkillRatio)
	army = indexToArmy(self:GetArmy())
	for i, currentArmy in armyStats do
		if(currentArmy[1] == army)then
			afficherFinJoueur( army )
		end
	end
	self.OldOnKilled(self, instigator, type_, overkillRatio)self.OldOnKilled(self, instigator, type_, overkillRatio)
end

function isACU( bpId )
  --Blackops ACU compatibility
	if(bpId=="ual0001" or bpId=="uel0001" or bpId=="url0001" or bpId=="xsl0001" or bpId=="eal0001" or bpId=="eel0001" or bpId=="erl0001" or bpId=="esl0001") then
		return true
	else
		return false
	end
end

function afficherFinJoueur( army )
	ForkThread(function()
		local execFinJoueurDejaEnCours = false
		for armyIndex, currentArmy in armyStats do
			if(currentArmy[1] == army)then 
				if(currentArmy[5] == "executionFinJoueur")then  --Execution d�j� en cours ?
					execFinJoueurDejaEnCours = true
				else
					currentArmy[5] = "executionFinJoueur" --Execution a faire
					local place = 0
					if currentArmy[2] <= 0 then --gagnant
						place = premierePlace
						premierePlace = premierePlace + 1
					else
						place = dernierePlace
						dernierePlace = dernierePlace - 1
					end
					scoreTable[place] = getPlace(place).." : "..currentArmy[4]
					actualiserScores = true
					
					
					--On remet la couleur du joueur � celle de d�part
					remettreCouleurOrigine(army)
					
					local indexASupprimer = nil
					for i, currentArmy in armyStats do
						if army == currentArmy[1] then
							indexASupprimer = i
						end
					end
					if indexASupprimer != nil then
						table.insert(ended, army)
						table.remove(armyStats, indexASupprimer)
			
						if(table.getn(armyStats) == 1)then -- il ne reste plus qu'un joueur ?
							afficherFinJoueur(armyStats[1][1])
						end
						
						local tmpArmyStats = {} --Tous les joueurs restants sont alli�s ?
						for w, currentArmyStats in armyStats do
							table.insert(tmpArmyStats, currentArmyStats[1])
						end
						if(areAllied(tmpArmyStats))then
							for w, currentArmyStats in armyStats do
								afficherFinJoueur(currentArmyStats[1])
							end
						end
					end
					
				end
			end
		end
		
		if(not execFinJoueurDejaEnCours)then
			WaitSeconds(5) --On attend que le score se mette � jour

			for index, brain in ArmyBrains do
				armyToKill = indexToArmy(brain:GetArmyIndex())
				if(army == armyToKill) then
					brain:AbandonedByPlayer(brain)
				end
			end
		end
	end)
end

function getPlace( place )
	if place==1 then
		place = languageText[language]["first"]
	else
		if place==nombreJoueurs then
			place = languageText[language]["last"]
		else
			if(place == 2)then
				place = languageText[language]["second"]	
			else
				if(place == 3)then
					place = languageText[language]["third"]	
				else
					place = place..languageText[language]["otherplace"]
				end
			end
		end
	end
	return place
end

function refreshLine()
	ForkThread(function()
		WaitSeconds( 1 )
		local colorIndex = { 
							"FFEF0808",
							"FF006500",
							"FF101CD6",
							"FFDEA621",
							"FFA5A6A5",
							"FF294D4A",
							"FF212021",
							"FF4A0400",
							"FF298A52",
							"FF8C28E7"
							}
		while (true) do
			local drawed = 0
		
			for i, currentArmy in armyStats do
				if(currentArmy[3] > 0) then
					local gaucheX = 234
					local droiteX = 278
					local largeur = (droiteX - gaucheX) * currentArmy[3] / 100
					for j=-0.1,0.1,0.01 do
						DrawLine({gaucheX,92.5,256+j+drawed},{droiteX,92.5,256+j+drawed}, "FF00FF00")
						DrawLine({gaucheX,92.5,256+j+drawed},{(gaucheX + largeur),92.5,256+j+drawed}, colorIndex[ScenarioInfo.ArmySetup[currentArmy[1]]["PlayerColor"]])
					end
					drawed = drawed + 0.4
				end
			end
			WaitSeconds( 0.1 )
		end
	end)
end


changeColor = function()
	local r = 0
	local g = 100
	local b = 200
	local rb = true
	local gb = true
	local bb = true

	local index = 0

	ForkThread(function()
		while true do
			WaitSeconds(0.04)
			for i=1,8 do
				if rb then
					r = r + 2
				else
					r = r - 2
				end
				if gb then
					g = g + 1
				else
					g = g - 1
				end
				if bb then
					b = b + 3
				else
					b = b - 3
				end
				if r > 252 then
					rb = false
				end
				if r < 3 then
					rb = true
				end
				if g > 252 then
					gb = false
				end
				if g < 3 then
					gb = true
				end
				if b > 252 then
					bb = false
				end
				if b < 3 then
					bb = true
				end
			end
			for index, currentArmy in armyStats do				
				if(currentArmy[3] == -1)then
					SetArmyColor(currentArmy[1],r,g,b)
				end
			end

		end
	end)
end

function remettreCouleurOrigine(army)
	for index, brain in ArmyBrains do --On lui remet sa couleur de d�part
		armyFromBrain = indexToArmy(brain:GetArmyIndex())
		if(armyFromBrain == army)then
			local indexAMettre = ScenarioInfo.ArmySetup[army]["PlayerColor"]
			SetArmyColorIndex(army, indexAMettre - 1 ) --Sont pas foutu de respecter les index de d�part !
		end
	end
end

function GenerateResourcesMarker(x, y)
	marker =
	{
		['Mass '..(100 + currentResSpot)] =
		{
			['type'] = STRING( 'Mass' ),
			['position'] = VECTOR3( x+0.50, 92.50, y+0.50 ),
			['orientation'] = VECTOR3( 0.00, 0.00, 0.00 ),
			['size'] = FLOAT( 1.00 ),
			['resource'] = BOOLEAN( true ),
			['amount'] = FLOAT( 100.00 ),
			['color'] = STRING( 'ff808080' ),
			['editorIcon'] = STRING( '/textures/editor/marker_mass.bmp' ),
			['prop'] = STRING( '/env/common/props/markers/M_Mass_prop.bp' ),
		},
	}
	currentResSpot = currentResSpot + 1
	CreateResources(marker)
end

function GenerateGasResourcesMarker(x, y)
	marker =
	{
		['Hydrocarbon '..(100 + currentResSpot)] =
		{
          ['type'] = STRING( 'Hydrocarbon' ),
          ['position'] = VECTOR3( x+0.50, 92.52, y+0.50 ),
          ['orientation'] = VECTOR3( 0.00, 0.00, 0.00 ),
          ['size'] = FLOAT( 3.00 ),
          ['amount'] = FLOAT( 100.00 ),
          ['color'] = STRING( 'ff008000' ),
          ['resource'] = BOOLEAN( true ),
          ['prop'] = STRING( '/env/common/props/markers/M_Hydrocarbon_prop.bp' ),
    },
	}
	currentResSpot = currentResSpot + 1
	CreateResources(marker)
end

function CreateResources(markers)
    --local markers = GetMarkers()

    for i, tblData in pairs(markers) do
        if tblData.resource then
            CreateResourceDeposit(
                tblData.type,
                tblData.position[1], tblData.position[2], tblData.position[3],
                tblData.size
            )

            local albedo, sx, sz, lod
            if tblData.type == "Mass" then
                albedo = "/env/common/splats/mass_marker.dds"
                sx = 2
                sz = 2
                lod = 100
                CreatePropHPR(
                    '/env/common/props/massDeposit01_prop.bp',
                    tblData.position[1], tblData.position[2], tblData.position[3],
                    Random(0,360), 0, 0
                )
            else
                albedo = "/env/common/splats/hydrocarbon_marker.dds"
                sx = 6
                sz = 6
                lod = 200
                CreatePropHPR(
                    '/env/common/props/hydrocarbonDeposit01_prop.bp',
                    tblData.position[1], tblData.position[2], tblData.position[3],
                    Random(0,360), 0, 0
                )
            end

            CreateSplat(
                tblData.position,           # Position
                0,                          # Heading (rotation)
                albedo,                     # Texture name for albedo
                sx, sz,                     # SizeX/Z
                lod,                        # LOD
                0,                          # Duration (0 == does not expire)
                -1 ,                         # army (-1 == not owned by any single army)
                0
            )
        end
    end
end

function refreshDialog() --Toutes les dialog se font ici, dans un seul thread, sinon ca pikote
	ForkThread( function(self)
		local myDialog = nil
		local myHelpDialog = nil
		local textPrecedent = ""
		while true do
			WaitSeconds( 1 );
			
			--DIALOG CAPTURE ET KINGS
			local kingText = ""
			local captureText = ""
			for i, currentArmyTemps in armyStats do --on parcours tous les joueurs

				if(currentArmyTemps[3]>0)then
					if(captureText == "")then
						captureText = languageText[language]["capture"]..math.floor(currentArmyTemps[3]).."% "..currentArmyTemps[4]
					else
						captureText = captureText.."\n"..languageText[language]["capture"]..math.floor(currentArmyTemps[3]).."% "..currentArmyTemps[4]
					end
				end

				if(currentArmyTemps[3]==-1)then
					if(kingText == "")then
						kingText = languageText[language]["king"]..currentArmyTemps[4]
					else
						kingText = kingText.." + "..currentArmyTemps[4]
					end
				end
			end
			

			if captureText..kingText != "" and myDialog == nil then --Texte non vide et boite inexistante ? on la cr��e
				myDialog = CreateDialogue( "...", nil, "right" )
				WaitSeconds(0.1) --Une petite pause car pour faire ou p�ter une dialog il faut laisser le code en carton g�rer tout �a tranquillement derri�re, sinon, marche pas !
			end
			
			if captureText..kingText == "" and myDialog != nil then --Texte vide et boite existante ? on la d�truit
				myDialog:Destroy()
				myDialog = nil
				WaitSeconds(0.1)
			end
			
			
			if textPrecedent != captureText.."\n"..kingText and captureText..kingText != "" and myDialog != nil then --Si le text a chang� et qu'il n'est pas vide alors on met � jour la boite
				textPrecedent = captureText.."\n"..kingText
				myDialog:SetText(textPrecedent)
				WaitSeconds(0.1)
			end
			
			
			--DIALOG TABLEAU FINAL
			if(actualiserScores)then
				actualiserScores = false
				local scoreInfos = ""
				for i, data in scoreTable do
					if( data != "" )then
						if( scoreInfos != "" )then
							scoreInfos = scoreInfos.."\n"
						end
						scoreInfos = scoreInfos..data
					end
				end
				if(scoreDialog!=nil)then
					scoreDialog:SetText(scoreInfos)
					WaitSeconds(0.1)
				end
				if(scoreDialog == nil)then
					scoreDialog = CreateDialogue( scoreInfos, nil, "left" )
					WaitSeconds(0.1)
				end
			end
			
			--DIALOG HELP
			local stringHelp = ""
			for indexHelp, currentHelp in helps do
				if(GetGameTimeSeconds() > currentHelp and GetGameTimeSeconds() < currentHelp + 10)then --On affiche l'aide
					if(stringHelp!="")then
						stringHelp = stringHelp.."\n"
					end
					if(indexHelp=="help1")then
						stringHelp = stringHelp..languageText[language]["help1"]
					end
					if(indexHelp=="help2")then
						stringHelp = stringHelp..languageText[language]["help2"]
					end
					if(indexHelp=="help3et4")then
						stringHelp = stringHelp..languageText[language]["help3"]..duree_king..languageText[language]["help4"]
					end
				end
			end
			if(myHelpDialog==nil and stringHelp!="")then
				myHelpDialog = CreateDialogue( stringHelp, nil, "right" )
				WaitSeconds(0.1)
			end
			if(myHelpDialog!=nil)then
				if(stringHelp !="")then
					myHelpDialog:SetText( stringHelp )
					WaitSeconds(0.1)
				else
					myHelpDialog:Destroy()
					myHelpDialog = nil
					WaitSeconds(0.1)
				end
			end
			
			
		end
	end)
end

function getAllied(army) --Retourne un tableau d'army alli� a l'army pass�e en param
	local allied = {}
	for i, currentArmy in armyStats do
		if(not IsEnemy(currentArmy[1], army) and currentArmy[1] != army)then
			table.insert(allied, currentArmy[1])
		end
	end
	return allied
end

function areAllied( armyTable )
	for i, army1 in armyTable do
		for j, army2 in armyTable do
			if IsEnemy(army1, army2)then
				return false
			end
		end
	end
	return true
end

function resetCapAndKing( armyTable )
	for i, army in armyTable do
		for i, currentArmy in armyStats do
			if(army == currentArmy[1])then
				currentArmy[2] = 0
				currentArmy[3] = 0
			end
		end
	end
end
